 {$INCLUDE POI_Export.config.pas}


var
    CacheName: string;      // Sbr zkracovan nzvy ke
    ThisCacheName: string;  // Jmno aktuln kee, zkrcen
    Ikony_kdes: string;     // oven adres


function SpojTypKese (T:string):string;
var S:string;
begin
  S := ReplaceString(T, 'Cave Entrances (Natural)', 'Natural Cave Entrances');
  S := ReplaceString(S, 'Historic Trees', 'Trees');
  S := ReplaceString(S, 'Exceptional Trees', 'Trees');
  S := ReplaceString(S, 'Historic Trees', 'Trees');
  Result := S;
end;

function DeleteTag(T,S:string;B:boolean):string;  // odstran z textu "S" zadan TAGy "T"; 
var I,J,K: Longint;                                 // ppadn obsah TAGu zmn na UPPERCASE;
    SL, SR:string;                                // tag se zadv jako lowercase;

begin
   SR := S;
   SL := '';
   I := pos('<'+ T, Lowercase(SR));               // hled zatek TAGu
   while (I > 0) and (length(SR) > 0) do
   begin
      SL := SL + copy(SR,1,I-1);                   // Ulo text pet TAGem
      SR := copy(SR,I,length(SR));     // zbytek textu k dal analze
      if (copy(SR,length(T)+1,1) = ' ') or
         (copy(SR,length(T)+1,1) = '>') or
         (copy(SR,length(T)+1,1) = '  ') then
        J := pos('>',SR)                 // hled uzavrac zvorku TAGov znaky
      else
        J := 0;                          // neni tag, ale text
      if J > 0 then                              
      begin
         SR := copy(SR,J+1,length(SR));        // odstran ze SR celou TAGovou znaku (otevrac)
         K := pos('</'+ T + '>', LowerCase(SR)); // hled uzavrac TAGovou znaku
         if K > 0 then
          begin
            If B then
            SL := SL + '(' + Uppercase(copy(SR,1,K-1)) + ')'    //  Obsah TAGu v zvorkch
            else
            SL := SL + '(' + copy(SR,1,K-1) + ')';     //  Obsah TAGu v zvorkch
           SR := copy(SR,K+length(T)+3,length(SR));  // Odstra penesen a TAG
          end;
      end
      else
      begin                                          // chyb uzavrac zvorka - asi soust textu
        SL := SL + copy (SR,1,length(T)+1);          //
        SR := copy (SR,length(T)+1,length(SR));
      end;
      I := pos('<'+ T, Lowercase(SR));               // hled zatek TAGu
   end;
   Result := SL + SR;
end;



{Tato metoda vytvori String strukturovany jako kus GPX dokumentu}
function FormatPointLight(wLat,wLon,wTime,wName,wDesc,wSym,wType,wIco: String): String;
begin
  Result :=
  + ' <wpt lat="' + wLat + '" lon="' + wLon + '">' + CRLF
  //+ '  <time>' + wTime + '</time>' + CRLF
  + '  <name>' + CDATA(wName) + '</name>' + CRLF
  + '  <cmt></cmt>' + CRLF
  + '  <desc>' + CDATA(UtfToAscii(HtmlImg2Link(wDesc))) + '</desc>' + CRLF
  + '  <link href="file://' + Ikony_kdes + '/' + wIco + '.bmp"/>' + CRLF
 // + '  <sym>' + wSym + '</sym>' + CRLF
 // + '  <type>' + wType + '</type>' + CRLF
  + ' </wpt>' + CRLF;
end;

{Tato metoda vytvori String strukturovany jako kus GPX dokumentu
 Radky oznacene jako "lze zakomentovat" v pripade potreby zakomentujte - hned 
 na zacatku radku pred plusem}
function FormatPoint(wLat,wLon,wTime,wName,wDesc,wSym,wType,wIco: String): String;
begin
  Result :=
  + ' <wpt lat="' + wLat + '" lon="' + wLon + '">' + CRLF
  + '  <time>' + wTime + '</time>' + CRLF //lze zakomentovat
  + '  <name>' + CDATA(wName) + '</name>' + CRLF
  + '  <cmt><![CDATA[]]></cmt>' + CRLF
  + '  <desc>' + CDATA(UtfToAscii(HtmlImg2Link(wDesc))) + '</desc>' + CRLF
//  + '  <url><![CDATA[]]></url>' + CRLF //lze zakomentovat
//  + '  <urlname><![CDATA[]]></urlname>' + CRLF //lze zakomentovat
  + '  <link href="file://' + Ikony_kdes + '/' + wIco + '.bmp"/>' + CRLF
  + '  <sym>' + wSym + '</sym>' + CRLF //lze zakomentovat
  + '  <type>' + wType + '</type>' + CRLF //lze zakomentovat
  + ' </wpt>' + CRLF;
end;

{Metoda vraci otucneny text}
function Bold(text : String) : String;
begin
  Result := '<b>' + text + '</b>';
end;

{Metoda vraci obarveny text}
function Color(Text, TargetColor: String) : String;
begin
  Result := '<font color=' + TargetColor + '>' + Text + '</font>';
end;

{Metoda vraci obarveny text}
function BGColor(Text, TargetColor: String) : String;
begin
  Result := '<font bgcolor=' + TargetColor + '>' + Text + '</font>';
end;

{Metoda vraci text se zmenenou velikosti}
function Size(Text, TargetSize: String) : String;
begin
  Result := '<font size=' + TargetSize + '>' + Text + '</font>';
end;

{Metoda vraci minimum z dvou predanych hodnot}
function Minimum(a, b : Integer) : Integer;
begin
  If a < b then Result := a
  else Result := b;
end;

function Je_nase: boolean;
begin
	Result := (pos(User1, lowercase(GC.Author)) > 0) or
	          (pos(User2, lowercase(GC.Author)) > 0) or
	          (pos(User3,	lowercase(GC.Author)) > 0) or
	          (pos(User4,	lowercase(GC.Author)) > 0) or
	          (pos(User5,	lowercase(GC.Author)) > 0) or
		   GC.IsOwner or
		   GC.TagHaveCategory('Nase')
end;

Function StateSymbol(geo:Tgeo):string;
begin
  if geo.IsArchived then      Result := Sym_Archi   //Vbr sprvnho symbolu
    else if geo.IsFound then    Result := Sym_Found
    else if geo.IsDisabled then Result := Sym_Disab
    else                       Result := '';
end;

function ProcessHint(Hint:string): string;
var HintOut: string;
begin
    if HintRot = '1' then HintOut := Rot13(Hint) else HintOut := Hint;
    if HintRevers = '1' then HintOut := Reverse(HintOut);
    Result := HintOut;
end;

{Metoda zpracuje predany bod TGeo a vrati naformatovany kod GPX}
function ProcessGeo(geo: TGeo) : String;
var
  	wLat,wLon,wDate,wName,wDesc,wSym,wType,wIco,status: string;
	n : Integer;
	IsWM: boolean;
	
begin
      //poskladame parametry
      wLat := geo.Lat;
      wLon := geo.Lon;
      wDate := formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', geo.Hidden);
      status := '';
        if geo.isFound then      status := status + Sym_Found;
        if geo.isArchived then   status := status + Sym_Archi
        else
        if geo.isDisabled then   status := status + Sym_Disab;
        if not (status = '') then status := status + ' ';        
       IsWM := (copy(geo.ID,1,2)='WM'); 
	
// Name Odstrann uvozovek, rek, dvojmezer 
      if GC_AS_NAME = '0' then
        begin                  // Name = cel jmno
          if IsWM then
            wName := UtfToAscii('WM ' + ReplaceString(ReplaceString(ReplaceString(geo.Name, '  ', ' '), ',', ''), '"', '')+ ' ' + geo.ID)
          else
            wName := UtfToAscii(geo.IDTag + ' ' + status + ReplaceString(ReplaceString(ReplaceString(geo.Name, '  ', ' '), ',', ''), '"', ''));
          
          wDesc := 
            Bold('Typ: ' + SpojTypKese (geo.CacheType)) + '<br>Autor: ' + Bold(geo.Author) + ' dne: ' + Bold(formatdatetime('dd". "mm". "yyyy', geo.Hidden)) + '<hr>'
        end
      else                     // Name = jen GC kd; jmno mus bt v wDesc
        begin
          if IsWM then
            begin
              wName := UtfToAscii(geo.ID);
              wDesc := UtfToAscii('WM ' + ReplaceString(ReplaceString(ReplaceString(geo.Name, '  ', ' '), ',', ''), '"', '')+ ' ' + geo.ID + '<hr>')
            end  
          else
            begin
              wName := UtfToAscii(geo.ID + ' ' + geo.IDTag + ' ' + status);
              wDesc := UtfToAscii(geo.IDTag + ' ' + status + ReplaceString(ReplaceString(ReplaceString(geo.Name, '  ', ' '), ',', ''), '"', '') +  '<hr>');
            end;
          wDesc :=  wDesc +
            Bold('Typ: ' + SpojTypKese (geo.CacheType)) + '<br>Autor: ' + Bold(geo.Author) + ' dne: ' + Bold(formatdatetime('dd". "mm". "yyyy', geo.Hidden)) + '<hr>'
        end;  
// stav
        if geo.isArchived then      wDesc := wDesc + Color(Bold('ARCHIVOVANA kes!'),TEXT_COLOR_DISABLED) + '<br>'
        else
        if geo.isDisabled then      wDesc := wDesc + Color(Bold('Docasne zruseno!'),TEXT_COLOR_DISABLED) + '<br>';
        if geo.isFound then         wDesc := wDesc + Color(Bold('Nalezl jsi dne: ' + formatdatetime('dd". "mm". "yyyy', geo.Found) +'.'),TEXT_COLOR_FOUND) + '<br>';
        wDesc := wDesc + '<br>'; 
// ID
        if IsWM Then
        begin
          wDesc := wDesc + BgColor (Size(Bold('WM ID:    ') + geo.ID, '3') + '<br>',TEXT_COLOR_FOUND);
        end
        else
          wDesc := wDesc + Size(Bold('ID:    ') + geo.ID, '3') + '<br>';

// D/T, size
        wDesc := wDesc + Bold('D / T  :  ') + geo.Difficulty + ' / ' + geo.Terrain + '<br>' +
        Bold('Velikost: ') + geo.Size + '<br>';
// parametry
        if (geo.TagHaveCategory(ELEVATION_TAG))  then wDesc := wDesc + Bold('Nadmorska vyska: ') + geo.TagValues(ELEVATION_TAG) + ' m.n.m.<br>';
        if (geo.TagHaveCategory(EVALUATION_TAG)) then wDesc := wDesc + Bold('Hodnoceni: ') + geo.TagValues(EVALUATION_TAG) + '<br>';
        wDesc := wDesc + '<br>' +
        Bold('Aktualizace: ') + formatdatetime('dd". "mm". "yyyy', geo.Updated) + '<br>' +
        Bold('Posl. nalez: ') + formatdatetime('dd". "mm". "yyyy', geo.LastFound);
        if not (geo.Comment = '') then wDesc := wDesc +  + '<br><br>' + Bold('Vlastni komentar: ') + geo.Comment;
// Hint
        if not (geo.Hint = '') then wDesc := wDesc +  + '<br><br>' + Bold('Hint: ') + ProcessHint(geo.Hint);
        if ((EXPORT_LISTING = '1') AND (geo.HaveListing)) then
        begin
          wDesc := wDesc + '<br><hr>' + Bold('Listing:') + '<br>' + ReplaceString(geo.ShortDescription, '  ', ' ') + '<br>';
          wDesc := wDesc + '<p><p>Popis:<p>';
          if (Hide_Tags = '1') then 
            wDesc := wDesc + ReplaceString(ReplaceString(DeleteTag('a',DeleteTag('img',geo.LongDescription,True),False), '  ', ' '), '<strong>Visit Instructions:</strong>', '<hr><p><b>Podminky logu:</b><br>')
          else
            wDesc := wDesc + ReplaceString(geo.LongDescription, '  ', ' ');
        end;
        
// logy        
        if (EXPORT_LOGS_MAXCOUNT <> '0') then
        begin
          if geo.Logs.count > 0 then 
          begin
            wDesc := wDesc + '<br><hr><hr>' + Bold('Logy:') + '<br>'
          
            for n := 0 to Minimum(geo.Logs.count - 1,StrToInt(EXPORT_LOGS_MAXCOUNT)-1) do
            begin
              wDesc := wDesc + Bold(geo.Logs[n].Finder + ' (' + formatdatetime('dd". "mm". "yyyy', geo.Logs[n].Date) + ', ' + geo.Logs[n].LogType + '):') + '<br>';
              wDesc := wDesc + geo.Logs[n].Text + '<br><br>';
            end;
          end;
        end;

// een ikony
      wSym := 'Geocache';
	    if geo.IsFound then wSym := 'Geocache Found';
      wType := 'Geocache|' + SpojTypKese (geo.CacheType);
      if Je_nase then
        begin							//  Vlastn keka jakhokoli typu
           wIco := 'Cache_MY';
	      end
      else
        if geo.IsFound then
          begin							// Jakkoli nalezen ke
            wIco := 'Caches_found';
          end
    	  else
    	    if IsWM Then
             begin
                wIco := ReplaceString(SpojTypKese (geo.CacheType), ' ', '_');
             end
           else
             begin							// Nenalezen kee - kad svou ikonu
               if copy(geo.ID,1,6) = 'Kofola' then
                 wIco := 'Cache_' + 'TK'
               else
                 wIco := 'Cache_' + geo.TypeID;
               if geo.IsArchived then wIco := wIco + Append_Archive;
               if geo.IsDisabled then wIco := wIco + Append_Disable;
	  end;
    
      //potom nechame logiku bod zpracovat
      Result := FormatPoint(wLat, wLon, wDate, wName, wDesc, wSym, wType, wIco);
end;

{Metoda zpracuje predany bod TWpt a vrati naformatovany kod GPX}
function ProcessWpt(wpt : TWpt) : String;
var
    geo : TGeo;
    wLat,wLon,wDate,wName,wDesc,wSym,wType,wIco,status: string;
    IsWM: boolean;
    
begin 
      //ziskame referenci na materskou kesku
      geo := wpt.ParentGeo;
      //poskladame parametry
      wLat := wpt.Lat;
      wLon := wpt.Lon;
      wDate := formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', geo.Hidden);
      status := '';
        if geo.isFound then      status := status + Sym_Found;
        if geo.isArchived then   status := status + Sym_Archi
        else
        if geo.isDisabled then   status := status + Sym_Disab;
        if not (status = '') then status := status + ' ';        
       IsWM := (copy(geo.ID,1,2)='WM'); 

        if IsWM then
          wName := 'WM/' + wpt.PrefixID + ' ' + status + UtfToAscii(geo.Name) + ' (' + UtfToAscii(wpt.Name) + ')'
        else
          wName := geo.IDTag + '/' + wpt.PrefixID + ' ' + status + UtfToAscii(geo.Name) + ' (' + UtfToAscii(wpt.Name) + ')';
        if geo.isArchived then      wDesc := wDesc + Color(Bold('ARCHIVOVANO!'),TEXT_COLOR_DISABLED) + '<br>'
        else
        if geo.isDisabled then      wDesc := wDesc + Color(Bold('Docasne zruseno!'),TEXT_COLOR_DISABLED) + '<br>';
        if geo.isFound then         wDesc := wDesc + Color(Bold('Tuto kes jsi nasel dne: ' + formatdatetime('dd". "mm". "yyyy', geo.Found) +'.'),TEXT_COLOR_FOUND) + '<br>';
        wDesc := wDesc + '<br>' +
        Bold('ID: ') +  wpt.ID  +' (' + geo.ID + ')' +'<br>' +
        Bold('Type: ') + wpt.WptType + '<br>';
        if (wpt.WptType = 'Final Location') then 
        begin
          wDesc := wDesc + 
          Bold('Difficulty: ') + geo.Difficulty + '<br>' +
          Bold('Size: ') + geo.Size + '<br>';
          if not (geo.Hint = '') then wDesc := wDesc + '<br><br>' + BgColor(Bold('Hint: ') + Reverse(geo.Hint), TEXT_COLOR_FOUND);
        end;
        if not (wpt.Description = '') then wDesc := wDesc + '<br>' + Bold('Description: ') + wpt.Description + '<br>';
        if not (wpt.Comment = '') then wDesc := wDesc + '<br>' + Bold('User comment: ') + wpt.Comment;
        
      wSym := wpt.WptType;
      wType := 'Waypoint|' + wpt.WptType;
      if (wpt.TypeID = 'P') then      //Export for Waypoints ... PARKING -------------------------
           begin
              wIco := 'WPT_P';
           end
      else
      if wpt.IsFinal then
      begin
        if Je_nase then
          begin							// vlastn FINAL
             wIco := 'Cache_MY';
          end
          else
             if GC.IsFound then
             begin							// ji nalezen FINAL
                wIco := 'Caches_found';
             end
             else
             begin							// znm FINALKA, vhodn k hledn
                wIco := 'Cache_TU'; // modr krabika
             end
      end
      else                          // ostatn body  
        wIco := '/WPT_' + wpt.TypeID;

      //potom nechame logiku bod zpracovat
      Result := FormatPoint(wLat, wLon, wDate, wName, wDesc, wSym, wType, wIco);
end;
