//GeoGet 2
{
  Export do formatu Garmin POI
  Do GPS nahraje napr. POILoader
  
  Exportuje jeden soubor, v nem jsou rozliseny typy kesi a waypointu.
  Kazda z techto kategorii ma vlastni ikonu, ktera musi byt pro POILoader na disku.
  Je nutne ve zdroji nastavit jmena souboru s obrazky.

  Ale hlavne: toto makro se vola z makra POI_Export.ggP.pas

  Potom probehne export do nekolika souboru, takze pak v GPS jsou v ruznych databazich
	kesky, ktere lze hledat rovnou (tradicky, finalni WPT)
	multikese
	mysterky (vyzaduje pripravu)
	ostatni kese (vyzaduje jen drobnou pripravu, za priznivych okolnosti lze hledat rovnou)
	parkoviste
	ostatni waypointy
}
                                     //24
 {$INCLUDE Formaty_textu.pas}
 
// function JeNase:boolean;
                                     //65 .... 65-24 = 41

{
	Ikony ke: Cache_T,	 kde T pedstavuje typ kee;
			T tradika,
			M multicache
			U mysterka
			G Earthcache
			I WhereIGo
			H LetterBox
                        E Event  Z Megaevent
			R LocationLess (ReversCache)
			V Virtual
			W WebCam
			MY nae


	Ikony	waypoint:  WPT_T, kde T pedstavuje typ waypointu; pro Traihead T, Question Q, Reference R, ...
			T Traihead	(tudy projdi)
			Q Question	(podvej se, spoti,...)
			R Reference point	(upozornn na zajmavost)
			S Stage of multicache (jen tam sm leet krabika s kolem, souadnicemi,...)

	Ikony zvltnch waypoint:
		F Finlky (znm):	Cache_TU.bmp (zvltn typ waypointu)
		P Parkovit: 		WPT_P.bmp

	Kee i finlky nalezench ke: Caches_found.bmp
	Kee i finlky vlastnch ke: Cache_MY.bmp (jen pokud je volno z makra "POI_Export.ggP.pas")

	Ppona a formt ikon je vdy ".bmp".
}
Const
	Kes_Z = 'TMUGIHRVWEZC';	// seznam znmch typ ke
	WPT_Z = 'TQRSFP';		// seznam znmch typ waypoint

var
	Solo: boolean;		// odli, zda je volno samostatn, nebo z makra "POI_Export.ggP.pas"
	Kesky, Body: string;	// Sbr typy ke a waypoint.
  Cesta_kamsi: string;    // oven clov adres

function ExportExtension: string;
begin
  Result := 'GPX';
end;

function ExportDescription: string;
begin
  Result := 'Submakra pro komplexn GPX POI';
end;

function LastPos(substr, s: string): Longint;  // najdi posledn substr v s
var i,j:longint;
begin
   i := length(s);
   j := 0;
   while (i > 0) and (j = 0) do
   begin
      if copy(s,i,1) = substr then j := i;
      i := i-1;
   end;
   result := j;
end;


                     // pevede relativn adresu na absolutn.
                     
function ResolveDir (DirIn:string; Slash:string):string;
var DirOut, DirIn2:  string;

begin
   if length(DirIn) = 0 then
      DirIn2 := Geoget_Datadir
    else
      DirIn2 := ReplaceString(DirIn, '/', '\');          // sjednocen lomtek na backslash
   if DirIn2[1] = '\' then DirOut := copy(Geoget_Datadir,1,2) + DirIn2
   else
   begin
     if LastPos('\', DirIn2) = length(DirIn2) then DirIn2 := copy(DirIn2, 1, length(DirIn2)-1);
     if (DirIn2 = '') or (DirIn2 = '.') then DirIn2 := Geoget_Datadir;
     if DirIn2[2] = ':' then   DirOut := DirIn2;
     if copy(DirIn2,1,2) = '..'  then
       begin
         DirOut := Geoget_Datadir;
         if length(DirIn2) > 2 then while (copy(DirIn2,1,3) =  '..\') and (length(DirOut)>3) do
         begin
            DirOut := copy(DirOut,1,LastPos('\',DirOut)-1);
            DirIn2 := copy(DirIn2,4,length(DirIn2));
         end;
         if DirIn2 = '..' then
         begin
            DirOut := copy(DirOut,1,LastPos('\',DirOut)-1);
            DirIn2 := '';
         end;
         DirOut := DirOut + '\' + DirIn2;
       end
       else
       begin
          if copy(DirIn2,1,2) = '.\'  then
          begin
             DirOut := Geoget_ScriptDir + '\GeoPOI' + copy(DirIn2,2,length(DirIn2));
          end
       end;
   end;
   if not(DirectoryExists(DirOut)) then 
      if not(ForceDirectories(DirOut)) then ShowMessage('Nepodailo se vytvoit chybjc adres: ' + DirOut);
   Result := ReplaceString(DirOut, '\', Slash);
end;


function ExportHeader: string;
begin
  Result := '<?xml version="1.0" encoding="utf-8"?>' + CRLF;
  Result := Result + '<gpx xmlns="http://www.topografix.com/GPX/1/1"'
    + ' creator="GeoGet" version="1.1"'
    + ' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"'
    + ' xsi:schemaLocation="http://www.garmin.com/xmlschemas/GpxExtensions/v3'
                        + ' http://www.garmin.com/xmlschemas/GpxExtensions/v3/GpxExtensionsv3.xsd'
                        + ' http://www.topografix.com/GPX/1/1'
                        + ' http://www.topografix.com/GPX/1/1/gpx.xsd">' + CRLF;
  Solo := true;
  Kesky := '';
  Body  := '';
  CacheName  := '';
  Ikony_kdes := Ikony_kde;
  Ikony_kdes := ReplaceString(ResolveDir (Ikony_kdes, '/'),' ','%20');
end;



function ExportFooter: string;
begin
  Result := '</gpx>' + CRLF;
	if Solo then
	begin
	  if Kesky <> '' then Showmessage('Byly nalezeny neznm typy ke: ' + Kesky);
	  if Body <> '' then Showmessage('Byly nalezeny neznm typy Waypoint: ' + Body);
	end
end;

function OneLine(s: string): string;        // odstran z etzce nepouiteln 
//   znaky
var GCH: string;
begin
  GCH := ReplaceString(s,'<br>','-');
  GCH := ReplaceString(GCH,CRLF,'-' );
  GCH := ReplaceString(GCH,#10,'-' );
  GCH := ReplaceString(GCH,'"','');
  GCH := ReplaceString(GCH, '', 'a');
  GCH := ReplaceString(GCH, '', 'o');
  GCH := UtfToAscii(GCH);
  Result := GCH;
end;

function SmartName(s: string): string;
var
  s1: string;  // zdrojov etzec
  d1: string;  // clov etzec
  e1: string;  //  poadov slo
  n, i:  integer;  // potadlo
  c: char;
  Mezera: boolean;
begin
  s1 := UtfToAscii(s);
  // zmnit neascii znaky, kter chceme zachovat
  s1 := ReplaceString(s1, '', 'a');
  s1 := ReplaceString(s1, '', 'o');

  // zkrcen jmno na 12 znak ASCII+sla
  n := 1;
  d1 := '';
  Mezera := true;
  while (Length(d1) < 12) and (n <= Length(s1)) do
    begin
      c := s1[n];
      if ((c>='0') and (c<='9')) or ((c>='A') and (c<='Z')) or ((c>='a') and (c<='z')) then
        begin
          if Mezera then
          begin
             d1 := d1 + Uppercase(c);
          end
          else
          begin
             d1 := d1 + Lowercase(c);
          end;
          Mezera := false;
        end
        else Mezera := true;
        n := n + 1;
    end;
    if pos(d1, CacheName) > 0 then // zajitn jednoznanosti
    begin
       d1 := copy(d1,1,10);
       i := 0;
       repeat
          i := i + 1;
          e1 := inttostr(i);
          if length(e1) = 1 then e1 := '0' + e1;
       until (pos(d1 + e1, CacheName)=0) or (i = 99);
       d1 := d1 + e1;
    end;
    CacheName := CacheName +  '!' + d1;
  Result := d1
end;


function ExportStrucne: string;
var HintOut: string;
    GC_Type: string;
    GC_Name: string;

begin
  Result := '';
  //Export for Geocaches
  ThisCacheName :=  SmartName(GC.Name);
//  if gc.islisted then
  begin
    if HintRot = '1' then HintOut := Rot13(GC.Hint) else HintOut := GC.Hint;
    if HintRevers = '1' then HintOut := Reverse(HintOut);
    Result := Result + ' <wpt lat="' + GC.Lat + '" lon="' + GC.Lon + '">' + CRLF;
    Result := Result + '  <time>'
      + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', GC.Hidden) + '</time>' + CRLF;
    GC_Type := GC.TypeID;
    if copy(GC.ID,1,6) = 'Kofola' then GC_Type :='TK'; 
    if GC.IsArchived then
       begin
          GC_Name := GC.TypeID + Sym_Archi + ThisCacheName;
          GC_Type := GC_Type + Append_Archive;
       end
    else if GC.IsFound then
       begin
          GC_Name := GC.TypeID + Sym_Found + ThisCacheName
//          GC_Type := GC_Type + Append_Found; neuplatn se - nen nutno definovat
       end
    else if GC.IsDisabled then
       begin
          GC_Name := GC.TypeID + Sym_Disab + ThisCacheName;
          GC_Type := GC_Type + Append_Disable;
       end
    else if GC.Size = 'Waymark' Then
       begin
          GC_Name := '_:' + ThisCacheName;
          GC_Type := ReplaceString(GC.CacheType, ' ', '_');
       end
    else if GC.TypeID = 'Z' Then
       begin
          GC_Name := 'E:' + ThisCacheName; // MegaEvent jako event
       end
    else
       GC_Name := GC.TypeID + ':' + ThisCacheName;
    Result := Result + '  <name>' + cdata(GC_Name) + '</name>' + CRLF;
    if GC.Size = 'Waymark' Then
      begin
         Result := Result + '  <desc>' + cdata('WM ' + GC.CacheType + '(' + GC.ID + ') ' + GC.Name ) + '</desc>' + CRLF;
      end
    else
      Result := Result + '  <desc>' + cdata('(' + GC.ID + ') ' + GC.Name
                     + ' (' + GC.Difficulty + '/' + GC.Terrain + ')' + ' ' + GC.Size
                     + ':' + OneLine(HintOut))+ '</desc>' + CRLF;

// POILOADER URL nema rad
//    Result := Result + '  <url>' + cdata(GC.URL) +'</url>' + CRLF;
//    Result := Result + '  <urlname>' + cdata(GC.Name + ' by ' + GC.Author) + '</urlname>' + CRLF;

    if Solo then
    begin								// obecn ke, nepouije-li se GGP
       Result := Result + '  <link href="file://' + Ikony_kdes + '/Cache.bmp"/>' + CRLF;
       Result := Result + '  <sym>Geocache</sym>' + CRLF
    end
    else
       if Je_nase then
          begin							//  Vlastn keka jakhokoli typu
             Result := Result + '  <link href="file://' + Ikony_kdes + '/Cache_MY.bmp"/>' + CRLF;
             Result := Result + '  <sym>Geocache</sym>' + CRLF
	  end
       else
          if GC.IsFound then
          begin							// Jakkoli nalezen ke
            Result := Result + '  <link href="file://' + Ikony_kdes + '/Caches_found.bmp"/>' + CRLF;
            Result := Result + '  <sym>Geocache Found</sym>' + CRLF
          end
    	  else
          begin							// Nenalezen kee - kad svou ikonu
            Result := Result + '  <link href="file://' + Ikony_kdes + '/Cache_' + GC_Type + '.bmp"/>' + CRLF;
            Result := Result + '  <sym>Geocache</sym>' + CRLF
	  end;
	  // kon if GC.IsFound
	// kon if Je_nase
    // kon if Solo

    Result := Result + '  <type>Geocache|' + GC.CacheType + '</type>' + CRLF;
    Result := UtfToAscii(Result) + ' </wpt>' + CRLF + CRLF;
    if (pos(GC.TypeID, Kes_Z)= 0) and (pos(GC.TypeID, Kesky)= 0) and not (GC.Size = 'Waymark') then
    begin
	  Kesky := Kesky + GC.TypeID;
         ShowMessage ('Ke:' + GC.Name + 'Neznm typ:' + GC.TypeID);
    end;
  end;
end;


function ExportCache: string;
begin
  if Ukecanost = '0' then
    Result := ExportStrucne
  else
    Result := ProcessGeo(GC);
end;

function Export1WPT_Strucny(n:integer): string;
var
  sw: string;
  GC_SymState: string;
  
begin
  Result := '';
  //Export for Waypoints
//  if (GC.Waypoints[n].IsListed) than
  if (GC.Waypoints[n].Lat[1] <> '0') and (GC.Waypoints[n].Lon[1] <> '0') then
    begin
      Result := Result + ' <wpt lat="' + GC.Waypoints[n].Lat + '" lon="' + GC.Waypoints[n].Lon + '">' + CRLF;
      Result := Result + '  <time>'
        + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', GC.Hidden) + '</time>' + CRLF;

    if GC.IsArchived then      GC_SymState := Sym_Archi   //Vbr sprvnho symbolu
    else if GC.IsFound then    GC_SymState := Sym_Found
    else if GC.IsDisabled then GC_SymState := Sym_Disab
    else                       GC_SymState := ':';

	if (GC.Waypoints[n].TypeID = 'P') then      //Export for Waypoints ... PARKING -------------------------
           begin
              sw := ThisCacheName + ':' + GC.Waypoints[n].TypeID + ':' + copy(GC.Waypoints[n].ID, 1, 2);
              Result := Result + '  <name>' + cdata(sw) + '</name>' + CRLF;
              Result := Result + '  <desc>' + cdata('(' + GC.ID + ') '
                               + GC.Name + ':'
                               + GC.Waypoints[n].TypeID + ':'
                               + GC.Waypoints[n].Name   + ':'
                               + OneLine(GC.Waypoints[n].Description)) +'</desc>' + CRLF;
              Result := Result + '  <link href="file://' + Ikony_kdes + '/WPT_P.bmp"/>' + CRLF;
              Result := Result + '  <sym>' + GC.Waypoints[n].WptType + '</sym>' + CRLF
           end
	else if GC.Waypoints[n].IsFinal then	    //Export for Waypoints ... FINAL -------------------------
           begin
              sw := 'F' + copy(GC.Waypoints[n].ID, 1, 2) + GC_SymState + ThisCacheName;
              Result := Result + '  <name>' + cdata(sw) + '</name>' + CRLF;
              Result := Result + '  <desc>' + cdata('(' + GC.ID + ') '
                               + GC.Name + ':'
                               + GC.Waypoints[n].TypeID + ':'
                               + GC.Waypoints[n].Name   + ':'
                               + ' (' + GC.Difficulty + '/' + GC.Terrain + ') '
                               + GC.Size   +
                               + OneLine(GC.Waypoints[n].Description)) +'</desc>' + CRLF;
              if Solo then
                 begin								// obecn FINAL, nepouije-li se GGP
                    Result := Result + '  <link href="file://' + Ikony_kdes + '/Cache.bmp"/>' + CRLF;
                    Result := Result + '  <sym>Geocache</sym>' + CRLF
                 end
              else
                 if Je_nase then
                    begin							// vlastn FINAL
                       Result := Result + '  <link href="file://' + Ikony_kdes + '/Cache_MY.bmp"/>' + CRLF;
                       Result := Result + '  <sym>Geocache</sym>' + CRLF
                    end
                    else
                       if GC.IsFound then
                       begin							// ji nalezen FINAL
                          Result := Result + '  <link  href="file://' + Ikony_kdes + '/Caches_found.bmp"/>' + CRLF;
                          Result := Result + '  <sym>Geocache Found</sym>' + CRLF
                       end
                       else
                       begin							// znm FINALKA, vhodn k hledn
                          //Result := Result + '  <link href="file://' + Ikony_kdes + '/Cache_' + GC.TypeID + '.bmp"/>' + CRLF; // podle typu
                          Result := Result + '  <link href="file://' + Ikony_kdes + '/Cache_TU.bmp"/>' + CRLF; // modr krabika
                          Result := Result + '  <sym>Geocache</sym>' + CRLF
                       end;
                      // kon if GC.IsFound
                   // kon if Je_nase
               // kon if Solo
	     end				// kon if GC.Waypoints[n].IsFinal
	else					     //Export for Waypoints ... other -------------------------
	     begin
	        sw := copy(GC.Waypoints[n].ID, 3, 7) + GC_SymState + GC.Waypoints[n].TypeID + copy(GC.Waypoints[n].ID, 1, 2);
	        Result := Result + '  <name>' + cdata(sw) + '</name>' + CRLF;
	        Result := Result + '  <desc>' + cdata(GC.Name + ':'
                                 + GC.Waypoints[n].TypeID + ':'
                                 + GC.Waypoints[n].Name + ':'
                                 + OneLine(GC.Waypoints[n].Description)) +'</desc>' + CRLF;
	        Result := Result + '  <link href="file://' + Ikony_kdes + '/WPT_' + GC.Waypoints[n].TypeID + '.bmp"/>' + CRLF;
	        Result := Result + '  <sym>' + GC.Waypoints[n].WptType + '</sym>' + CRLF
	     end;
	// konec rozdlnch jmennch konvenc pro PARKING FINAL ostatn WPT
//      Result := Result + '  <url>' + cdata(GC.Waypoints[n].URL) +'</url>' + CRLF;
//      Result := Result + '  <urlname>' + cdata(GC.Waypoints[n].Name) + '</urlname>' + CRLF;

      Result := Result + '  <type>Waypoint|' + GC.Waypoints[n].WptType + '</type>' + CRLF;
      Result := UtfToAscii(Result) + ' </wpt>' + CRLF + CRLF;
      if (pos(GC.Waypoints[n].TypeID, WPT_Z)= 0) and (pos(GC.Waypoints[n].TypeID, Body)= 0) then
      begin
	  Body := Body + GC.Waypoints[n].TypeID;
      end;
   end;
end;


function Export1WPT(n:integer): string;
begin
  if (Ukecanost = '0') or (Ukecanost = '1') then
    Result := Export1WPT_Strucny(n)
  else
    Result := ProcessWpt(GC.Waypoints[n]);
end;



function ExportPoint:string;
var
	R: string;
	n: integer;
begin
	Solo := true;
	R := ExportCache;
	for n := 0 to GC.Waypoints.Count - 1 do
	   R := R + Export1WPT(n);
	Result := R;
end;


function ExportAfter(value: string): string;

begin
	RunShell( value );
end;
